def relu(input: Tensor,
    inplace: bool=False) -> Tensor:
  if inplace:
    result = torch.relu_(input)
  else:
    result = torch.relu(input)
  return result
def log_softmax(input: Tensor,
    dim: Optional[int]=None,
    _stacklevel: int=3,
    dtype: Optional[int]=None) -> Tensor:
  _0 = __torch__.torch.nn.functional._get_softmax_dim
  if torch.__is__(dim, None):
    dim1 = _0("log_softmax", torch.dim(input), _stacklevel, )
    dim0 = dim1
  else:
    dim0 = unchecked_cast(int, dim)
  if torch.__is__(dtype, None):
    ret = torch.log_softmax(input, dim0)
  else:
    dtype0 = unchecked_cast(int, dtype)
    ret0 = torch.log_softmax(input, dim0, dtype0)
    ret = ret0
  return ret
def batch_norm(input: Tensor,
    running_mean: Optional[Tensor],
    running_var: Optional[Tensor],
    weight: Optional[Tensor]=None,
    bias: Optional[Tensor]=None,
    training: bool=False,
    momentum: float=0.10000000000000001,
    eps: float=1.0000000000000001e-05) -> Tensor:
  _1 = __torch__.torch.nn.functional._verify_batch_size
  if training:
    _2 = _1(torch.size(input), )
  else:
    pass
  _3 = torch.batch_norm(input, weight, bias, running_mean, running_var, training, momentum, eps, True)
  return _3
def _max_pool1d(input: Tensor,
    kernel_size: List[int],
    stride: Optional[List[int]]=None,
    padding: List[int]=[0],
    dilation: List[int]=[1],
    ceil_mode: bool=False,
    return_indices: bool=False) -> Tensor:
  if torch.__is__(stride, None):
    stride0 = annotate(List[int], [])
  else:
    stride0 = unchecked_cast(List[int], stride)
  _4 = torch.max_pool1d(input, kernel_size, stride0, padding, dilation, ceil_mode)
  return _4
def _get_softmax_dim(name: str,
    ndim: int,
    stacklevel: int) -> int:
  _5 = "Implicit dimension choice for {} has been deprecated. Change the call to include dim=X as an argument."
  torch.warn(torch.format(_5, name), stacklevel)
  if torch.eq(ndim, 0):
    _6 = True
  else:
    _6 = torch.eq(ndim, 1)
  if _6:
    _7 = True
  else:
    _7 = torch.eq(ndim, 3)
  if _7:
    ret = 0
  else:
    ret = 1
  return ret
def _verify_batch_size(size: List[int]) -> NoneType:
  _8 = "Expected more than 1 value per channel when training, got input size {}"
  size_prods = size[0]
  size_prods0 = size_prods
  for i in range(torch.sub(torch.len(size), 2)):
    size_prods1 = torch.mul(size_prods0, size[torch.add(i, 2)])
    size_prods0 = size_prods1
  if torch.eq(size_prods0, 1):
    ops.prim.RaiseException(torch.format(_8, size), "builtins.ValueError")
  else:
    pass
  return None
